#define BOOST_TEST_MAIN
#include <boost/test/included/unit_test.hpp>
#include <Datum.h>

BOOST_AUTO_TEST_SUITE(datum_operator_plus_plus)

BOOST_AUTO_TEST_CASE(tag)
{
  Datum d(1, 1, 2020);
  for (int tag = 2; tag <= 31; ++tag) {
    ++d;
    BOOST_CHECK(d.tag() == tag);
  }
}

BOOST_AUTO_TEST_CASE(einfacher_monatswechsel)
{
  Datum d(31, 1, 2021);
  ++d;
  BOOST_CHECK(d.tag() == 1);
  BOOST_CHECK(d.monat() == 2);
}


BOOST_AUTO_TEST_CASE(alle_monatswechsel)
{
  int tageImMonat[] {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
  for (int monat = 1; monat <= 12; ++monat) {
    auto letzterTagImMonat = tageImMonat[monat-1];
    int jahr{2021};                               // TESTJAHR
    // Schaltjahr ist durch 4 teilbar, aber nicht durch 100, es sei denn, durch 400
    if (((jahr % 4 == 0) && (jahr % 100 != 0)) || (jahr % 400 == 0)) {
      if (monat == 2) {
        letzterTagImMonat = 29;
      }
    }
    Datum d(letzterTagImMonat, monat, jahr);
    ++d;
    BOOST_CHECK(d.tag() == 1);
    if (monat < 12) {
      BOOST_CHECK(d.monat() == monat + 1);
    }
    else {
      BOOST_CHECK(d.monat() == 1);
    }
  }
}

BOOST_AUTO_TEST_CASE(schaltjahr)
{
  for (int jahr = 1800; jahr < 2300; ++jahr) {
    bool schaltjahr =          // durch 4 teilbar, aber nicht durch 100,
                               // es sei denn, durch 400
        ((jahr % 4 == 0) && (jahr % 100 != 0)) || (jahr % 400 == 0);
    Datum d(28, 2, jahr);
    ++d;
    if (schaltjahr) {
      BOOST_REQUIRE(d.tag() == 29);
      BOOST_REQUIRE(d.monat() == 2);
    }
    else {
      BOOST_REQUIRE(d.tag() == 1);
      BOOST_REQUIRE(d.monat() == 3);
    }
  }
}


BOOST_AUTO_TEST_SUITE_END()
