#include <numeric>
#include <showContainer.h>
#include <vector>
using namespace std;

int main()
{
  vector<long> v(10);
  iota(v.begin(), v.end(), 0);               // 0 1 2 3 4 5 6 7 8 9
  vector<long> adjacDiff(10);
  cout << "Differenzen     = ";
  adjacent_difference(v.begin(), v.end(),    // Quelle
                      adjacDiff.begin());    // Ziel
  showContainer(adjacDiff);                  // 0 1 1 1 1 1 1 1 1 1
  // Zweite Variante: Statt der (vorgegebenen) Differenz wird ein anderer Operator,
  // hier plus<int>() übergeben. Im Beispiel werden damit Fibonacci-Zahlen erzeugt.
  vector<int> fib(16);
  fib[0] = 1;                                // Anfangswert
  // Ein Startwert genügt hier, weil der erste Wert an Position 1 eingetragen wird
  //  (Formel e_i = v_i - v_{i-1} oben) und sich damit der zweite Wert von selbst ergibt
  // (beachte den um 1 verschobenen result-Iterator in der Parameterliste).
  cout << "Fibonacci-Zahlen  = ";
  adjacent_difference(fib.begin(), fib.end()-1,  // Quelle
                      fib.begin()+1,             // Ziel
                     plus<int>());               // Funktor
  showContainer(fib);              // 1 1 2 3 5 8 13 21 34 55 89 144 233 377 610 987
}

