#include <algorithm>
#include <numeric>
#include <random>                            // mt19937
#include <showContainer.h>
#include <vector>
using namespace std;

bool istNegativ(int x) { return x < 0; }

int main()
{
  vector<int> v(12);
  iota(v.begin(), v.end(), -6);
  ranges::shuffle(v, mt19937());             // verwürfeln
  vector<int> unstable {v};
  vector<int> stable {v};

  cout << "In negative und positive Elemente zerlegen\n";
  cout << "Sequenz vor der Zerlegung :";
  showContainer(v);                          // -2 4 5 2 -6 -1 -4 -5 0 3 -3 1

  cout << "stabile Partitionierung   :";
  ranges::stable_partition(stable, istNegativ);
  showContainer(stable);                     // -2 -6 -1 -4 -5 -3 4 5 2 0 3 1

  cout << "unstabile Partitionierung :";
  ranges::partition(unstable, istNegativ);
  // Die Elemente innerhalb einer Partition sind nicht mehr in ihrer ursprünglichen Reihenfolge:
  showContainer(unstable);                   // -2 -3 -5 -4 -6 -1 2 5 0 3 4 1

  if (ranges::is_partitioned(unstable, istNegativ)) {
    cout << "Folge ist partioniert. Der erste Wert des zweiten Teils ist "
         << *ranges::partition_point(unstable, istNegativ) << '\n';
  }

  vector<int> negativeZahlen(v.size());
  vector<int> positiveZahlen(v.size());
  cout << "Zerlegung in negative und positive Zahlen:\n";
  auto iterTripel = ranges::partition_copy(v, negativeZahlen.begin(),
                                           positiveZahlen.begin(), istNegativ);
  cout << "Partition 1: ";
  for (auto iter = negativeZahlen.begin(); iter != iterTripel.out1; ++iter) {
    cout << *iter << ' ';
  }
  cout << "\nPartition 2: ";
  for (auto iter = positiveZahlen.begin(); iter != iterTripel.out2; ++iter) {
    cout << *iter << ' ';
  }
  cout << '\n';
}

