#include <algorithm>
#include <iostream>
#include <iterator>
#include <numeric>
#include <showContainer.h>
#include <string_view>
#include <vector>
using namespace std;

int main()
{
  vector<char> v(26);
  iota(v.begin(), v.end(), 'a');             // Alphabet mit Kleinbuchstaben erzeugen
  showContainer(v, "\n", "");
  cout << "remove 't': ";
  auto last = ranges::remove(v, 't').begin();
  // last = neues Ende nach der Verschiebung, v.end() bleibt unverändert!
  // Die Sequenz wird hier nicht mit showContainer() angezeigt, weil nur
  // die Zeichen von begin() bis Iterator last von Bedeutung sind.
  ostream_iterator<char> ausgabe(cout, "");
  copy(v.begin(), last, ausgabe);            // abcdefghijklmnopqrsuvwxyz   (t fehlt)
  cout << '\n';
  // Vokale entfernen:
  last = ranges::remove_if(ranges::subrange(v.begin(), last), 
     [](char c) {  return string_view {"aeiouyAEIOUY"}.find(c) 
                                   != std::string_view::npos;}
                          ).begin();
  cout << "nur noch Konsonanten übrig: ";
  copy(v.begin(), last, ausgabe);            // bcdfghjklmnpqrsvwxz
  cout << "\nVollständige Sequenz einschließlich bedeutungsloser "
          "Elemente am Ende:\n";
  showContainer(v, "\n", "");
}

