#include <chrono>
#include <ctime>
#include <filesystem>
#include <iostream>
#include <string>
namespace fs = std::filesystem;

int main(int argc, char* argv[])
{
  if (argc < 2) {
    std::cout << "Gebrauch: " << argv[0] << " name\n";
  }
  else {
    std::string verz {argv[1]};
    try {
      fs::path pfad(verz);
      fs::directory_iterator di(pfad), ende;
      while (di != ende) {
        auto p = di->path();
        std::cout << p.filename() << '\t';
        if (fs::is_directory(p)) {
          std::cout << " (Verzeichnis)\n";
        }
        else {
          std::cout << fs::file_size(p) << " Bytes\n";
        }
        ++di;
      }
    }
    catch (const std::exception& e) {
      std::cerr << "Anzeige des Verzeichnisses " << argv[1] 
                << " fehlgeschlagen:\n" << e.what() << '\n';
    }
  }
}
