#ifndef SIMPLESTACK2_T
#define SIMPLESTACK2_T
#include <cassert>

template <typename T, int maxSize>
class SimpleStack2 {
public:
  bool empty() const { return anzahl == 0; }
  bool full() const { return anzahl == maxSize; }
  int size() const { return anzahl; }
  void clear() { anzahl = 0; }          // Stack leeren

  const T& top() const;          // letztes Element sehen
  void pop();                    // Element entnehmen
  // Vorbedingung für top und pop: Stack ist nicht leer

  void push(const T& x);          // x auf den Stack legen
  // Vorbedingung für push: Stack ist nicht voll

private:
  int anzahl{0};          // Anfangswert
  T array[maxSize];                // Behälter für Elemente
};

// noch fehlende Implementierungen
template <typename T, int m>          // Parameter m wird nicht benutzt
const T& SimpleStack2<T, m>::top() const
{
  assert(!empty());
  return array[anzahl - 1];
}

template <typename T, int m>          // Parameter m wird nicht benutzt
void SimpleStack2<T, m>::pop()
{
  assert(!empty());
  --anzahl;
}

template <typename T, int m>          // Parameter m wird nicht benutzt
void SimpleStack2<T, m>::push(const T& x)
{
  assert(!full());
  array[anzahl++] = x;
}
#endif

