#ifndef BESCHRIFTETESRECHTECK_H
#define BESCHRIFTETESRECHTECK_H
#include "../../abstrakt/Rechteck.h"
#include "BeschriftetesObjekt.h"

// Mehrfachvererbung
class BeschriftetesRechteck : public BeschriftetesObjekt,
                              public Rechteck {          // Mehrfachvererbung
public:
  BeschriftetesRechteck(Ort ort, int h, int b, std::string_view beschriftung)
      : BeschriftetesObjekt(ort, beschriftung), Rechteck(ort, h, b)
  { }

  // Definition der rein virtuellen Methoden
  virtual double flaeche() const override
  {
    // Definition ist notwendig, damit die Klasse nicht abstrakt ist
    // (durch Vererbung über BeschriftetesObjekt und GraphObj))
    return Rechteck::flaeche();
  }

  virtual void zeichnen() const override
  {
    Rechteck::zeichnen();
    BeschriftetesObjekt::zeichnen();
  }
};
#endif

