#include <iostream>
#define PRINT(X) std::cout << (#X) << " = " << (X) << '\n' // siehe Seite 139

class Basis {
  double bWert;
public:
  Basis(double b = 0.0) 
  : bWert(b) 
  {}

  virtual ~Basis()                          // virtueller Destruktor!
  {
    std::cout << "Objekt " << bWert << " Basis-Destruktor aufgerufen!\n";
  }

  Basis(const Basis&) = delete;             // Regel der großen Drei, siehe Seite 314
  Basis& operator=(const Basis&) = delete;  // dito
};

class Abgeleitet : public Basis {
  double aWert;
public:
  Abgeleitet(double b = 0.0, double a = 0.0) 
  : Basis(b), aWert(a) 
  {}

  ~Abgeleitet()
  { 
    std::cout << "Objekt " << aWert << " Abgeleitet-Destruktor aufgerufen!\n"; 
  }
  
  Abgeleitet(const Abgeleitet&) = delete;  // Regel der großen Drei, siehe Seite 314
  Abgeleitet& operator=(const Abgeleitet&) = delete;  // dito
};

int main()
{
  Basis* pb = new Basis(1.0);
  PRINT(sizeof(*pb));
  Abgeleitet* pa = new Abgeleitet(2.0, 2.2);
  PRINT(sizeof(*pa));
  Basis* pba = new Abgeleitet(3.0, 3.3);
  PRINT(sizeof(*pba));
  std::cout << "pb löschen:\n";
  delete pb;                                // ok
  std::cout << "pa löschen:\n";
  delete pa;                                // ok
  std::cout << "pba löschen:\n";
  delete pba;                               // ok nur mit virtuellem Destruktor!
}

