#include "Teilnehmer.h"
#include <iostream>

Teilnehmer::Teilnehmer(const std::string& n) : name{n} {}

void Teilnehmer::lerntKennen(Teilnehmer& tn)
{
  if (&tn != this               // 'sich selbst kennenlernen' ignorieren
      && !kennt(tn)) {          // wenn noch unbekannt, eintragen
    dieBekannten.push_back(tn.gibNamen());
    tn.lerntKennen(*this);          // wechselseitig kennenlernen
  }
}

bool Teilnehmer::kennt(const Teilnehmer& tn) const
{
  bool erg{false};
  for (const auto& bekannte : dieBekannten) {
    if (tn.gibNamen() == bekannte) {
      erg = true;
      break;
    }
  }
  return erg;
}

void Teilnehmer::druckeBekannte() const
{
  for (const auto& bekannte : dieBekannten) {
    std::cout << "  " << bekannte;
  }
  std::cout << '\n';
}

const std::string& Teilnehmer::gibNamen() const { return name; }
