#ifndef MEINSTRING_H
#define MEINSTRING_H
#include <iostream>                                // ostream
#include <vector>

class MeinString {
public:
  MeinString(const char* str = "");                // allg. Konstruktor
  MeinString& assign(const char*);                 // Zuweisung eines char*
  const char& at(int position) const;              // Zeichen holen
  char& at(int position);                          // Zeichen holen
  // Wegen des Rückgabetyps Referenz kann das Zeichen geändert werden.
  int length() const { return daten.size() - 1; }  // Anzahl der Zeichen
  auto data() const { return daten.data(); }       // Zeiger auf Inhalt zurückgeben
  void swap(MeinString&);                          // vertauschen
  auto begin() const { return daten.begin(); }
  auto end() const { return daten.end(); }
  const char& operator[](int position) const;  // Zeichen holen
  char& operator[](int position);              // Zeichen holen
  MeinString& operator+=(const MeinString& m);
private:
  std::vector<char> daten;
};

void anzeigen(std::ostream& os, const MeinString& m);
std::ostream& operator<<(std::ostream& os, const MeinString& m);
MeinString operator+(MeinString m1, const MeinString& m2);
#endif

